#ifndef SERIAL_H
#define SERIAL_H

#define BAUD 19200
#define BUFFER_SIZE 1024

#include <util/setbaud.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>
#include <stdlib.h>

const bool serialFlowControl = false;

class Serial
{
private:
    char _terminator = '\n';
    
    
public:
    Serial();
    void putChar(const char c);
    void write(const char* in, const unsigned int length);
    void write(const char in[]);
    void write(const int32_t in);
    bool dataIsWaiting();
    char getChar();
    unsigned int getString(char* buffer, const int bufferLength);
    void flush();    
    void setTerminator(const char terminator);
};

#endif

